#include <at89x52.h>
#include "MyHeader.h"
#include "LCDDriver.c"

void Keypad_ISR(void) interrupt 0
{
		ISR_LED=~ISR_LED;
		R1=0;R2=R3=R4=1;
		if(C1==0)
		{
			Key='1';
			return;
		}
		else if(C2==0)
		{
			Key='2';
			return;
		}
		else if(C3==0)
		{
			Key='3';
			return;
		}	

		R2=0;R1=R3=R4=1;
		if(C1==0)
		{
			Key='4';
			return;
		}
		else if(C2==0)
		{
			Key='5';
			return;
		}
		else if(C3==0)
		{
			Key='6';
			return;
		}
		
		R3=0;R1=R2=R4=1;

		if(C1==0)
		{
			Key='7';
			return;
		}
		else if(C2==0)
		{
			Key='8';
			return;
		}
		else if(C3==0)
		{
			Key='9';
			return;
		}
		
		R4=0;R1=R2=R3=1;
		if(C1==0)
		{
			Key='*';
			return;
		}
		else if(C2==0)
		{
			Key='0';
			return;
		}
		else if(C3==0)
		{
			Key='#';
			return;
		}		
}
void Access(void)
{
	unsigned char pwd[4]="0";
	unsigned char i=0;
  LCDCommand(0x01);
	LCDCommand(0x80);
	WriteString("User ID:");
	for(i=0;i<4;i++)
	 {
		 Key=0;
		 R1=R2=R3=R4=0;
		 while(Key==0);
		 LCDData(Key);
		 Key=0;
	 }
	LCDCommand(0xC0);
	WriteString("Password:");
	for(i=0;i<4;i++)
	 {
		 R1=R2=R3=R4=0;
		 while(Key==0);
		 pwd[i]=Key;
		 LCDData('*');
		 Key=0;
	 }
	if((pwd[0]==PWD[0]) &&
		 (pwd[1]==PWD[1]) &&
		 (pwd[2]==PWD[2]) &&
		 (pwd[3]==PWD[3]))
	 {
		LCDCommand(0x01);
		LCDCommand(0x06);	
		LCDCommand(0x80);
		WriteString("Authenticated!");
		LCDCommand(0xC0);
		WriteString("       OK!    ");
	 }
	else
	{
		LCDCommand(0x01);
		LCDCommand(0x06);	
		LCDCommand(0x80);
		WriteString("Access Denied!");
		LCDCommand(0xC0);
		WriteString("  Try Again!  ");		
	}	
	do
	 {		 
		 Key=0;
		 R1=R2=R3=R4=0;
		 while(Key==0);
	 }while(Key!='#');
	//Further Application Here.		 
}
void main(void)
{
	P2=0;
	R1=R2=R3=R4=0;
	C1=C2=C3=1;
	IE = 0x81; //Enable INT0 interrupt.
	TCON = 0x01; //Edge-triggered interrupt.
	ISR_LED = 0;
	LCDCommand(0x38);
	LCDCommand(0x0E);
	LCDCommand(0x01);
	LCDCommand(0x06); //Till here we have done the LCD initialization.
	
	LCDCommand(0x80);
	WriteString("Welcome ECE@VCE!");
	LCDCommand(0xC0);
	WriteString("  e-UI Project  ");
	do
	 {		 
		 Key=0;
		 R1=R2=R3=R4=0;
		 while(Key==0);
	 }while(Key!='#');
	Access();
}